package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysResourceMapper;
import com.gic.auth.dto.ResourceDTO;
import com.gic.auth.entity.TabSysResource;
import com.gic.auth.service.ResourceService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GlobalInfo;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/28 18:29
 */
@Service
public class ResourceServiceImpl implements ResourceService {

    @Autowired
    private TabSysResourceMapper tabSysResourceMapper;

    @Override
    public Integer save(ResourceDTO resourceDTO) {
        TabSysResource resource = EntityUtil.changeEntityByOrika(TabSysResource.class, resourceDTO);
        resource.setStatus(GlobalInfo.DATA_STATUS_NORMAL);
        resource.setCreateTime(new Date());
        return tabSysResourceMapper.insertSelective(resource);
    }

    @Override
    public Integer update(ResourceDTO resourceDTO) {
        TabSysResource resource = EntityUtil.changeEntityByOrika(TabSysResource.class, resourceDTO);
        return tabSysResourceMapper.updateByPrimaryKeySelective(resource);
    }

    @Override
    public Integer delResource(Integer resourceId) {
        TabSysResource resource = new TabSysResource();
        resource.setStatus(GlobalInfo.DATA_STATUS_DELETE);
        resource.setResourceId(resourceId);
        return tabSysResourceMapper.updateByPrimaryKeySelective(resource);
    }

    @Override
    public Page<TabSysResource> listResource(ResourceDTO resourceDTO, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        return tabSysResourceMapper.listResource(resourceDTO);
    }

    @Override
    public TabSysResource getResource(Integer resourceId) {
        return tabSysResourceMapper.selectByPrimaryKey(resourceId);
    }

    @Override
    public boolean isRepeatByResourceName(Integer enterpriseId, String resourceName, Integer resourceId) {
        TabSysResource resource = tabSysResourceMapper.getBySelective(enterpriseId, resourceName, resourceId);
        return resource != null;
    }
}
